%define current_version 0.1.47

Name: phaul
Version: %{current_version}
Release:        1%{?dist}
Summary: Tool to live-migrate containers and processes
Group: System Environment/Base
License: GPLv2
URL: http://criu.org/p.haul
Source0: %{name}-%{version}.tar.bz2
Patch0: 0001-p.haul-temporary-set-max-verbosity-level.patch
BuildArch: noarch
Requires: python2 >= 2.7
Requires: python-criu >= 3.4.0.25
Requires: protobuf-python
Requires: python-ipaddr
Requires: python-ploop
Requires: libvzctl >= 7.0.382
Requires: ploop >= 7.0.90
BuildRequires: python2-devel >= 2.7
BuildRequires: python-setuptools

%description
p.haul is the project on top of CRIU implementing live migration
usage scenario for containers and processes. p.haul stands for
process hauler.

%prep
%setup -q -n %{name}-%{version}

%patch0 -p1

%build
%{__python2} setup.py build

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_libexecdir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{python2_sitelib}/%{name}
%{__python2} setup.py install --skip-build --root %{buildroot} --install-scripts=/usr/libexec/phaul/

%clean
rm -rf $RPM_BUILD_ROOT

%files
%dir %{_libexecdir}/%{name}
%dir %{python2_sitelib}/%{name}
%attr(755,root,root) %{_libexecdir}/%{name}/p.haul
%attr(755,root,root) %{_libexecdir}/%{name}/p.haul-service
%{python2_sitelib}/%{name}/*
%{python2_sitelib}/*.egg-info
%doc README.md COPYING

%changelog
* Tue Nov 14 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.47
 - Increate a limit for opened files for criu pre-dump and page-server
\#PSBM-67194 (Andrei Vagin <avagin@openvz.org>)

* Mon Oct 02 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.45
 - Perform sync if VE has external DM disk #PSBM-72011

* Wed Sep 27 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.44
 - Remove 'minor + 1' logic for external disk #PSBM-72011 (Igor Sukhih
<igor@virtuozzo.com>)

* Wed Aug 30 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.43
 - Fix ghost file maximum size #PSBM-70891

* Mon Aug 28 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.42
 - Increase ghost file size limit to 4 Gb #PSBM-70557

* Thu Jul 13 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.41
 - Make first ve_sync non-blocking
 - Call extra sync only for containers with NFS inside #PSBM-68345

* Wed Jun 28 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.40
 - Fix timeout implementation #PSBM-67711

* Wed Jun 14 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.39
 - Fix style problems according to flake recommendations
 - Remove orphaned delta after shared storage migration #PSBM-67073

* Fri Jun 09 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.37
 - Kill source VE before unfreezing destination VE if NFS is inside #PSBM-65772

* Thu Jun 01 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.36
 - Call sync prior to the final dump #PSBM-66587
 - Add dummy alarm handler
 - Remove bogus files

* Mon Apr 17 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.35
 - Print errors on libploop exceptions #PSBM-62564

* Fri Apr 07 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.34
 - Remove images regardless of migration success #PSBM-47555

* Thu Apr 06 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.33
 - Fix cgroup controller generation list #PSBM-62583

* Wed Apr 05 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.31
 - Add ve and beancounter cgroup controllers #PSBM-62583

* Thu Mar 09 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.30
 - Add net_cls,net_prio cgroup controller to criu request #PSBM-61851

* Tue Mar 07 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.29
 - Fill in cgroup controller list for criu request #PSBM-61788

* Tue Mar 07 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.28
 - Add pids cgroup external mapping #PSBM-61639

* Thu Mar 02 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.27
 - Use tcp_skip_in_flight CRIU option unconditionally #PSBM-57008

* Wed Feb 15 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.26
 - fix --auto_dedup forward compatibility (Pavel Tikhomirov
<ptikhomirov@virtuozzo.com>) (#PSBM-60489)

* Fri Jan 27 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.25
 - Introduce action scripts executed on different stages (#PSBM-54143)

* Tue Jan 24 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.24
 - Drop ifdown from net_lock (Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com>)
(#PSBM-58351)
 - add --auto_dedup option (Pavel Tikhomirov <ptikhomirov@virtuozzo.com>)

* Tue Jan 24 2017 Pavel Vokhmyanin <pvokhmyanin@virtuozzo.com> 0.1.23
 - Generate cgroup external mount map dynamically (Pavel Vokhmyanin
<pvokhmyanin@virtuozzo.com>) (#PSBM-58433)

* Mon Dec 19 2016 Alexander Burluka <aburluka@virtuozzo.com> 0.1.21
 - Update .travis.yml (Dmitry Guryanov <dmitry.guryanov@virtuozzo.com>)
 - Add ability to specify destination ID on service side (Dmitry Guryanov
<dmitry.guryanov@virtuozzo.com>) (#PSBM-53148)
 - Fix setup.py according to new recommendations (Dmitry Guryanov
<dmitry.guryanov@virtuozzo.com>)
 - Fix syntax slightly to make flake8 happy (except tabs) (Dmitry Guryanov
<dmitry.guryanov@virtuozzo.com>)
 - Add ability to check PEP8 compliance with flake8 (Dmitry Guryanov
<dmitry.guryanov@virtuozzo.com>)

* Wed Dec 14 2016 Konstantin Volkov <wolf@virtuozzo.com> - 0.1.20-2
- Rebuild in 7.3 environment

* Mon Dec 12 2016 Alexander Burluka <aburluka@virtuozzo.com> 0.1.20
 - Fix rpc module name change (Dmitry Guryanov <dmitry.guryanov@virtuozzo.com>)

* Fri Sep 23 2016 Alexander Burluka <aburluka@virtuozzo.com> 0.1.18
 - Fix rollback for Virtuozzo container migration in restart mode

* Tue Aug 23 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.17
 - ignore existing old/obsoleted active delta files for ploop disks
 - fix path to freezer cgroup for Virtuozzo containers
 - increase dump and predump timeouts for Virtuozzo containers
 - specify secondary ploop disks as external in dump request options

* Tue Aug 23 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.16-3
- Remove merged to upstream patches

* Fri Jul 01 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.16-2
- Add 0007-p.haul-ignore-existing-old-obsoleted-active-delta-fi.patch, #PSBM-49076

* Fri Jul 01 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.16
- Internal rebuild for update1

* Wed Jun 22 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.15-3
- Add 0006-p.haul-fix-path-to-freezer-cgroup-for-Virtuozzo-cont.patch, #PSBM-48712

* Tue Jun 21 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.15-2
- Add 0005-p.haul-specify-secondary-ploop-disks-as-external-in-.patch, #PSBM-47398
- Add 0004-p.haul-minor-functions-reordering-in-Virtuozzo-haule.patch
- Add 0003-p.haul-add-Virtuozzo-specific-argument-to-pass-list-.patch

* Mon Jun 20 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.15
- Merge upstream

* Mon Jun 20 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.14-5
- Remove merged to upstream patches

* Tue Jun 14 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.14-4
- Add 0006-p.haul-increase-dump-and-predump-timeouts-for-Virtuo.patch, #PSBM-48256

* Mon Jun 13 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.14-3
- Add 0004-p.haul-specify-freezer-cgroup-for-predump-and-dump-r.patch, #PSBM-44613
- Add 0005-p.haul-make-it-possible-to-adjust-predump-request.patch

* Thu Jun 2 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.14-2
- Add 0003-p.haul-fix-error-handling-after-successfull-restore-.patch, #PSBM-42995

* Wed May 25 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.14
- Create Virtuozzo specific images during final dump, #PSBM-47399
- Forward correct verbosity level to criu restore
- Fix root_task_pid function for Virtuozzo containers

* Wed May 25 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13-6
- Remove merged to upstream patches

* Sat May 14 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13-5
- Add 0004-p.haul-minor-style-improvements-in-vz-module.patchi, #PSBM-46899
- Add 0005-p.haul-create-Virtuozzo-specific-dump-images-during-.patch, #PSBM-46899

* Wed May 4 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13-4
- Add 0003-p.haul-forward-correct-verbosity-level-to-criu-resto.patch, #PSBM-46597

* Fri Apr 29 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13-3
- Add 0002-p.haul-temporary-set-max-verbosity-level.patch

* Fri Apr 29 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13-2
 - Add 0001-p.haul-fix-root_task_pid-function-for-Virtuozzo-cont.patch

* Wed Apr 27 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.13
 - Improve subprocess output logging
 - Tweak loggers configuration, #PSBM-42988

* Wed Apr 20 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.12
 - handle migration with id change, #PSBM-41168

* Mon Apr 18 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.11
 - Prevent VZ CT ARP ping on destination restore
 - Add criu version check, #PSBM-45010

* Thu Apr 14 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.10
 - p.haul: implement vz migration with shared ploops, #PSBM-42981

* Tue Mar 29 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.9
 - Internal rebuild

* Tue Mar 29 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.8
 - p.haul: workaround bug in tarfile module
 - p.haul: fix bug in fileobj_wrap.write
 - p.haul: implement migration in so-called restart mode, #PSBM-41177
 - p.haul: fix memory tracking support detection

* Tue Mar 29 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.7-3
 - Remove backported patches

* Fri Mar 18 2016 Nikita Spiridonov <nspiridonov@virtuozzo.com> 0.1.7-2
 - Add patches needed to workaround bug in tarfile module, #PSBM-45137

* Thu Mar 10 2016 Nikita Spiridonov <nspiridonov@odin.com> 0.1.7
 - Add Makefile.version file
 - Modified for vzbuild br support (Konstantin <wolf@parallels.com>)

* Thu Mar 10 2016 Nikita Spiridonov <nspiridonov@odin.com> 0.1.7
 - Add Makefile.version file
 - Modified for vzbuild br support (Konstantin <wolf@parallels.com>)

* Wed Dec 23 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.6
- Handle multiploop containers live migration, #PSBM-41061

* Wed Nov 25 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.5
- Fix ct config handling in Virtuozzo module, #PSBM-41362

* Mon Nov 16 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.4
- Update to 0.1.4
- Add 0001-p.haul-workaround-bug-in-tarfile-library.patch

* Tue Nov 3 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.3-2
- Add 0001-p.haul-fix-vzctl-utility-calls-in-vz-module.patch

* Wed Oct 28 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.3
- Update to 0.1.3

* Mon Sep 7 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.2
- Fix Virtuozzo containers cgroups bug
- Implement Virtuozzo specific container restore

* Wed Aug 5 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.1-2
- Add 0001-p.haul-fix-Virtuozzo-containers-cgroups-bug.patch

* Wed Jul 15 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1.1-1
- Virtuozzo containers migration fixes

* Sun Apr 26 2015 Nikita Spiridonov <nspiridonov@odin.com> - 0.1-1
- Initial release
